﻿addEvent("onPlayerCreatedGroup",true)
addEvent("onPlayerDeletedGroup",true)

addEventHandler("onResourceStart",resourceRoot,function()
	executeSQLQuery("CREATE TABLE IF NOT EXISTS Groups_x22 (Account,NameGroup,RankPlayer,Owner,Event,Ruel)")
	executeSQLQuery("CREATE TABLE IF NOT EXISTS GrupsMembers_x22 (Account,NameGroup,RankPlayer,State,Name)")
	executeSQLQuery("CREATE TABLE IF NOT EXISTS GrupsInvite_x22 (Account,Name,NameGroup)")
	executeSQLQuery("CREATE TABLE IF NOT EXISTS GroupMoney_x22 (Account,Name,RankPlayer,NameGroup,Amount,Tick)")
	outputDebugString("Sql Group System , Loaded .",3)
	exports.scoreboard:addScoreboardColumn("NameGroup")
	exports.scoreboard:addScoreboardColumn("RankPlayer")
	for _,plrs in ipairs (getElementsByType("player")) do
		local acc = getPlayerAccount(plrs)
		if ( acc ) then
			if not( isGuestAccount(acc) ) then
				setElementData(plrs,"AccountName",tostring(getAccountName(acc)))
				local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(getAccountName(acc)))
				if ( type(Row) == "table" and #Row == 0 or not Row ) then
					setElementData(plrs,"NameGroup","N/A")
					setElementData(plrs,"RankPlayer","N/A")
				else
					setElementData(plrs,"NameGroup",tostring(Row[1]["NameGroup"]))
					setElementData(plrs,"RankPlayer",tostring(Row[1]["RankPlayer"]))
					local Row_ = executeSQLQuery("SELECT * FROM Groups_x22 WHERE NameGroup=?",tostring(Row[1]["NameGroup"]))
					if ( type(Row_) == "table" and #Row_ == 0 or not Row_ ) then
						return false
					else
						setElementData(resourceRoot,"Event"..tostring(Row_[1]["NameGroup"]).."",tostring(Row_[1]["Event"]))
						setElementData(resourceRoot,"Ruel"..tostring(Row_[1]["NameGroup"]).."",tostring(Row_[1]["Ruel"]))
						setElementData(resourceRoot,"Owner"..tostring(Row_[1]["NameGroup"]).."",tostring(Row_[1]["Owner"]))
					end
				end
			else
				setElementData(plrs,"AccountName","N/A")
				setElementData(plrs,"NameGroup","N/A")
				setElementData(plrs,"RankPlayer","N/A")
			end
		else
			setElementData(source,"AccountName","N/A")
			setElementData(plrs,"NameGroup","N/A")
			setElementData(plrs,"RankPlayer","N/A")
		end
	end
end)

addEventHandler("onPlayerJoin",root,function()
	setElementData(source,"AccountName","N/A")
	setElementData(source,"NameGroup","N/A")
	setElementData(source,"RankPlayer","N/A")
end)

addEventHandler("onPlayerLogin",root,function(_,account)
	setElementData(source,"AccountName",tostring(getAccountName(account)))
	local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(getAccountName(account)))
	if ( type(Row) == "table" and #Row == 0 or not Row ) then
		setElementData(source,"NameGroup","N/A")
		setElementData(source,"RankPlayer","N/A")
	else
		setElementData(source,"NameGroup",tostring(Row[1]["NameGroup"]))
		setElementData(source,"RankPlayer",tostring(Row[1]["RankPlayer"]))
		executeSQLQuery("UPDATE GrupsMembers_x22 SET State=? WHERE Account=?",tostring("Online"),tostring(getAccountName(account)))
	end
end)

addEventHandler("onPlayerLogout",root,function()
	local accountName = getElementData(source,"AccountName")
	local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(accountName))
	if ( type(Row) == "table" and #Row == 0 or not Row ) then
		return false
	else
		executeSQLQuery("UPDATE GrupsMembers_x22 SET State=? WHERE Account=?",tostring("Offline"),tostring(accountName))
	end
	setElementData(source,"AccountName","N/A")
	setElementData(source,"NameGroup","N/A")
	setElementData(source,"RankPlayer","N/A")
	triggerClientEvent(source,"DestroyGui",source)
end)

addEventHandler("onPlayerQuit",root,function()
	local accountName = getElementData(source,"AccountName")
	if ( accountName ~= "N/A" ) then
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(accountName))
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			return false
		else
			executeSQLQuery("UPDATE GrupsMembers_x22 SET State=? WHERE Account=?",tostring("Offline"),tostring(accountName))
		end
	end
end)

addEvent("CreateGroup",true)
addEventHandler("CreateGroup",root,function(NameGroup)
	local accountName = getElementData(source,"AccountName")
	local CheckNameGroup = executeSQLQuery("SELECT * FROM Groups_x22 WHERE NameGroup=?",tostring(NameGroup))
	if ( type(CheckNameGroup) == "table" and #CheckNameGroup == 0 or not CheckNameGroup ) then
		executeSQLQuery("INSERT INTO Groups_x22 (Account,NameGroup,RankPlayer,Owner,Event,Ruel) VALUES (?,?,?,?,?,?)",tostring(accountName),tostring(NameGroup),tostring("Owner"),tostring(string.gsub(getPlayerName(source),"#%x%x%x%x%x%x","")),tostring("None"),tostring("None"))
		executeSQLQuery("INSERT INTO GrupsMembers_x22 (Account,NameGroup,RankPlayer,State,Name) VALUES (?,?,?,?,?)",tostring(accountName),tostring(NameGroup),tostring("Owner"),tostring("Online"),tostring(string.gsub(getPlayerName(source),"#%x%x%x%x%x%x","")))
		outputChatBox("* Created New Group , Name Creator : "..getPlayerName(source).." / Name Group : "..tostring(NameGroup).."",source,0,255,255,true)
		triggerEvent("onPlayerCreatedGroup",source,source,NameGroup)
		setElementData(resourceRoot,"Event"..NameGroup.."","None")
		setElementData(resourceRoot,"Ruel"..NameGroup.."","None")
		setElementData(resourceRoot,"Owner"..NameGroup.."",tostring(string.gsub(getPlayerName(source),"#%x%x%x%x%x%x","")))
		setElementData(source,"NameGroup",tostring(NameGroup))
		setElementData(source,"RankPlayer",tostring("Owner"))
		for _,plrs in ipairs (getElementsByType("player")) do
			getAllGroups(plrs)
		end
	else
		outputChatBox("* [ Error ] You're Can't Use This Name .",source,255,0,0,true)
	end
end)

addEvent("UpGroups",true)
addEventHandler("UpGroups",root,function()
	for _,plrs in ipairs (getElementsByType("player")) do
		getAllGroups(plrs)
	end
	setElementData(resourceRoot,"CountGroups",getCountGroups())
	setElementData(resourceRoot,"CountMembers",getCountMembers())
end)

addEvent("UpMembers",true)
addEventHandler("UpMembers",root,function()
	for _,plrs in ipairs (getElementsByType("player")) do
		getAllMembers(plrs,getElementData(source,"NameGroup"))
	end
	setElementData(source,"OnlineInMyGroup",""..#getPlayersCountOnlineInMyGroup(source,getElementData(source,"NameGroup")).."")
	setElementData(source,"OfflineInMyGroup",""..#getPlayersCountOfflineInMyGroup(source,getElementData(source,"NameGroup")).."")
end)

addEvent("UpEvent",true)
addEventHandler("UpEvent",root,function(eventText)
	local NameGroup = getElementData(source,"NameGroup")
	executeSQLQuery("UPDATE Groups_x22 SET Event=? WHERE NameGroup=?",tostring(eventText),tostring(NameGroup))
	setElementData(resourceRoot,"Event"..NameGroup.."",tostring(eventText))
end)

addEvent("UpRuel",true)
addEventHandler("UpRuel",root,function(ruelText)
	local NameGroup = getElementData(source,"NameGroup")
	executeSQLQuery("UPDATE Groups_x22 SET Ruel=? WHERE NameGroup=?",tostring(ruelText),tostring(NameGroup))
	setElementData(resourceRoot,"Ruel"..NameGroup.."",tostring(ruelText))
end)

addEvent("InvitePlayer",true)
addEventHandler("InvitePlayer",root,function(Account)
	if ( Account and Account ~= false and Account ~= nil and string.len(Account) >= 1 ) then
		local MyAcc = getElementData(source,"AccountName")
		if ( Account == MyAcc ) then
			outputChatBox("* [ Error ] You're Can't Send Invite For You're Self .",source,255,0,0,true)
			return
		end
		local NameGroup_ = getElementData(source,"NameGroup")
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(Account))
		local Row_ = executeSQLQuery("SELECT * FROM GrupsInvite_x22 WHERE Account=?",tostring(Account))
		for i,v in ipairs (Row_) do
			if ( v.NameGroup == NameGroup_ ) then
				outputChatBox("* [ Error ] there invite For This Player Wait Accept or Deleted the Invite .",source,255,0,0,true)
				return
			end
		end
		executeSQLQuery("INSERT INTO GrupsInvite_x22 (Account,Name,NameGroup) VALUES (?,?,?)",tostring(Account),tostring(string.gsub(getPlayerName(source),"#%x%x%x%x%x%x","")),tostring(NameGroup_))
		outputChatBox("Send Invite Done .",source,0,255,255,true)
	else
		outputChatBox("* [ Error ] Select Player Please .",source,255,0,0,true)
	end
end)

addEvent("ViewMyInvite",true)
addEventHandler("ViewMyInvite",root,function()
	getAllInvites(source,getElementData(source,"AccountName"))
end)

addEvent("InviteAgre",true)
addEventHandler("InviteAgre",root,function(nameGroup,acc,name)
	if ( nameGroup and nameGroup ~= false and nameGroup ~= nil and string.len(nameGroup) >= 3 ) then
		local Row = executeSQLQuery("SELECT * FROM Groups_x22 WHERE NameGroup=?",tostring(nameGroup))
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			outputChatBox("* [ Error ] This Group Delted Now ,( Not Found ) .",source,255,0,0,true)
			return
		end
		if ( Row[1]["NameGroup"] == getElementData(source,"NameGroup") ) then
			outputChatBox("* [ Error ] You're in this Group .",source,255,0,0,true)
			return
		end
		local accountName = getElementData(source,"AccountName")
		executeSQLQuery("INSERT INTO GrupsMembers_x22 (Account,NameGroup,RankPlayer,State,Name) VALUES (?,?,?,?,?)",tostring(accountName),tostring(nameGroup),tostring("Member"),tostring("Online"),tostring(string.gsub(getPlayerName(source),"#%x%x%x%x%x%x","")))
		executeSQLQuery("DELETE FROM GrupsInvite_x22 WHERE NameGroup =? AND Account=? AND Name=?",tostring(nameGroup),tostring(acc),tostring(name))
		setElementData(source,"NameGroup",tostring(nameGroup))
		setElementData(source,"RankPlayer",tostring("Member"))
		getAllInvites(source,accountName)
	end
end)

addEvent("DeletedMyInvite",true)
addEventHandler("DeletedMyInvite",root,function(nameGroup,acc,name)
	if ( nameGroup and nameGroup ~= false and nameGroup ~= nil and string.len(nameGroup) >= 3 ) then
		executeSQLQuery("DELETE FROM GrupsInvite_x22 WHERE NameGroup =? AND Account=? AND Name=?",tostring(nameGroup),tostring(acc),tostring(name))
		getAllInvites(source,getElementData(source,"AccountName"))
	end
end)

addEvent("GiveRank",true)
addEventHandler("GiveRank",root,function(acc,GiveRank)
	if ( acc and acc ~= false and acc ~= nil and type(acc) == "string" and string.len(acc) >= 1 and GiveRank ) then
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(acc))
		local MyRank = getElementData(source,"RankPlayer")
		local MyAcc = getElementData(source,"AccountName")
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			outputChatBox("* [ Error ] Not Found Player In This Group .",source,255,0,0,true)
		else
			local PlayerToGiveRank = Row[1]["RankPlayer"]
			if ( acc == MyAcc ) then 
				outputChatBox("* [ Error ] You Can't Give Any Rank For You're Self .",source,255,0,0,true)
				return
			end
			if ( MyRank == "Moderator" or MyRank == "Member" ) then 
				outputChatBox("* [ Error ] You Can't Give Any Rank .",source,255,0,0,true)
				return
			end
			if ( MyRank == "Super Moderator" and GiveRank ~= "Moderator" and PlayerToGiveRank ~= "Member" ) then 
				outputChatBox("* [ Error ] You Can Just Give Member To Moderator .",source,255,0,0,true)
				return
			end
			if ( MyRank == "Admin" and GiveRank == "Owner" ) then 
				outputChatBox("* [ Error ] You Can't Give Onwer .",source,255,0,0,true)
				return
			end
			if ( MyRank == "Admin" and PlayerToGiveRank == "Owner" ) then 
				outputChatBox("* [ Error ] You Can't Change Rank Owner .",source,255,0,0,true)
				return
			end
			executeSQLQuery("UPDATE GrupsMembers_x22 SET RankPlayer=? WHERE Account=?",tostring(GiveRank),tostring(acc))
			outputChatBox("Get Rank Done .",source,0,255,255,true)
			getAllMembers(source,getElementData(source,"NameGroup"))
			local plr = getPlayerFromAccount(acc)
			if not( plr ) then
				return
			end
			setElementData(plr,"RankPlayer",tostring(rank))
		end
	else
		outputChatBox("* [ Error ] bad argument acc&rank .",source,255,0,0,true)
	end
end)

addEvent("GetKick",true)
addEventHandler("GetKick",root,function(acc)
	if ( acc and acc ~= false and acc ~= nil and type(acc) == "string" and string.len(acc) >= 1 ) then
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(acc))
		local MyRank = getElementData(source,"RankPlayer")
		local MyAcc = getElementData(source,"AccountName")
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			outputChatBox("* [ Error ] Not Found Player In This Group .",source,255,0,0,true)
		else
			local PlayerRankToGiveKick = Row[1]["RankPlayer"]
			if ( acc == MyAcc ) then 
				outputChatBox("* [ Error ] You Can't Give Kick For You're Self .",source,255,0,0,true)
				return
			end
			if ( MyRank == "Owner" and PlayerRankToGiveKick == "Owner" or MyRank == "Admin" and PlayerRankToGiveKick == "Owner" or MyRank == "Super Moderator"and PlayerRankToGiveKick == "Owner" ) then 
				outputChatBox("* [ Error ] You Can't Give Owner Kick .",source,255,0,0,true)
				return
			end
			if ( MyRank == "Super Moderator" and PlayerRankToGiveKick == "Admin" or MyRank == "Super Moderator" and PlayerRankToGiveKick == "Super Moderator" ) then
				outputChatBox("* [ Error ] You Can't Give Admin/Super Moderator Kick .",source,255,0,0,true)
				return
			end
			executeSQLQuery("DELETE FROM GrupsMembers_x22 WHERE Account = '"..tostring(acc).."'")
			if ( getElementData(source,"NameGroup") ~= "N/A" ) then
				getAllMembers(source,getElementData(source,"NameGroup"))
			end
			local plr = getPlayerFromAccount(acc)
			if not( plr ) then
				return
			end
			setElementData(plr,"RankPlayer",tostring("N/A"))
			setElementData(plr,"NameGroup",tostring("N/A"))
		end
	end
end)

addEvent("LeaveGroup",true)
addEventHandler("LeaveGroup",root,function()
	local acc = getPlayerAccount(source)
	if ( acc ) then
		if not ( isGuestAccount(acc) ) then
			local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE Account=?",tostring(getAccountName(acc)))
			if ( type(Row) == "table" and #Row == 0 or not Row ) then
				outputChatBox("* [ Error ] You're Haven't Group To Leave Of it.",source,255,0,0,true)
			else
				local RowCheckDeleted = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE NameGroup=?",tostring(Row[1]["NameGroup"]))
				if ( type(RowCheckDeleted) == "table" and #RowCheckDeleted == 1 ) then
					triggerEvent("onPlayerDeletedGroup",source,source,Row[1]["NameGroup"])
					executeSQLQuery("DELETE FROM GroupMoney_x22 WHERE NameGroup = '"..tostring(Row[1]["NameGroup"]).."'")
					executeSQLQuery("DELETE FROM GrupsInvite_x22 WHERE NameGroup = '"..tostring(Row[1]["NameGroup"]).."'")
					executeSQLQuery("DELETE FROM Groups_x22 WHERE NameGroup = '"..Row[1]["NameGroup"].."'")
					executeSQLQuery("DELETE FROM GrupsMembers_x22 WHERE Account = '"..tostring(Row[1]["Account"]).."'")
					outputChatBox("Leave / Deleted , Done .",source,0,255,255,true)
					outputChatBox("* Deleted Group , Name Player : "..getPlayerName(source).."",source,0,255,255,true)
					setElementData(source,"RankPlayer","N/A")
					setElementData(source,"NameGroup","N/A")
					getAllGroups(source)
				else
					executeSQLQuery("DELETE FROM GrupsMembers_x22 WHERE Account = '"..tostring(Row[1]["Account"]).."'")
					outputChatBox("Leave Done .",source,0,255,255,true)
					setElementData(source,"RankPlayer","N/A")
					setElementData(source,"NameGroup","N/A")
					getAllGroups(source)
				end
			end
		else
			outputChatBox("* [ Error ] You're Haven't Account/Group To Use This .",source,255,0,0,true)
		end
	end
end)

addEvent("ViewMembersSelectGroup",true)
addEventHandler("ViewMembersSelectGroup",root,function(NameGroup_Select)
	getAllMembersSelect(source,NameGroup_Select)
end)

addEvent("ViewListMoneyMyGroup",true)
addEventHandler("ViewListMoneyMyGroup",root,function(MyGroupName)
	getAllMoneyGroup(source,MyGroupName)
end)

addEvent("AddMoney",true)
addEventHandler("AddMoney",root,function(amount)
	local MyMoney = getPlayerMoney(source)
	if ( MyMoney >= tonumber(amount) ) then
		takePlayerMoney(source,tonumber(amount))
		local Tick = math.random(100,170) * math.random(170,190) / math.random(2,8)
		local accountName = getElementData(source,"AccountName")
		local MyRank = getElementData(source,"RankPlayer")
		local MyGroup = getElementData(source,"NameGroup")
		insertMoneyToSql = executeSQLQuery("INSERT INTO GroupMoney_x22 (Account,Name,RankPlayer,NameGroup,Amount,Tick) VALUES (?,?,?,?,?,?)",tostring(accountName),tostring(string.gsub(getPlayerName(source),"#%x%x%x%x%x%x","")),tostring(MyRank),tostring(MyGroup),tonumber(amount),tonumber(math.floor(Tick)))
		outputChatBox("* Add Money Done .",source,0,255,255,true)
		outputChatBox("* You're Money Now : [ "..getPlayerMoney(source).." ] .",source,0,255,255,true)
		if ( insertMoneyToSql ~= false ) then
			getAllMoneyGroup(source,MyGroup)
		end
	else
		outputChatBox("* [ Error ] You're Haven't Amount : [ "..amount.." ] To Add .",source,255,0,0,true)
	end
end)

addEvent("GiveMoneyMySelf",true)
addEventHandler("GiveMoneyMySelf",root,function(name,amount,account,tick)
	if ( tostring(name) and name ~= nil and name ~= false and tonumber(amount) and amount ~= nil and amount ~= false and tostring(account) and account ~= nil and account ~= false and tonumber(tick) and tick ~= nil and tick ~= false ) then
		givePlayerMoney(source,tonumber(amount))
		outputChatBox("You're Take Amount ,",source,0,255,255,true)
		outputChatBox("* The Amount : [ "..amount.." ]",source,0,255,255,true)
		outputChatBox("* Player Name : [ "..name.." ]",source,0,255,255,true)
		outputChatBox("* Player Account : [ "..account.." ]",source,0,255,255,true)
		outputChatBox("** You're Money Now : [ "..getPlayerMoney(source).." ]",source,0,255,255,true)
		deletedAmountOfSql = executeSQLQuery("DELETE FROM GroupMoney_x22 WHERE Tick=? AND Account=? AND Amount=? AND NameGroup=? AND Name=?",tonumber(tick),tostring(account),tonumber(amount),tostring(getElementData(source,"NameGroup")),tostring(name))
		if ( deletedAmountOfSql ~= false ) then
			getAllMoneyGroup(source,getElementData(source,"NameGroup"))
		else
			outputChatBox("* [ Error ] Fail Deleted Amount Of Sql .",source,255,0,0,true)
		end
	else
		outputChatBox("* [ Error ] Please Select Amount .",source,255,0,0,true)
	end
end)

addEvent("GiveMoneyAllOnline",true)
addEventHandler("GiveMoneyAllOnline",root,function(name,amount,account,tick)
	if ( tostring(name) and name ~= nil and name ~= false and tonumber(amount) and amount ~= nil and amount ~= false and tostring(account) and account ~= nil and account ~= false and tonumber(tick) and tick ~= nil and tick ~= false ) then
		local plrsOnline = getPlayersOnlineInMyGroup(source,getElementData(source,"NameGroup"))
		local countPlrsOnline = getPlayersCountOnlineInMyGroup(source,getElementData(source,"NameGroup"))
		local amount_ = math.floor(tonumber(amount)/tonumber(#countPlrsOnline))
		givePlayerMoney(plrsOnline,tonumber(amount_))
		outputChatBox("All Online In Group Take Money ,",plrsOnline,0,255,255,true)
		outputChatBox("* The Amount Of List : [ "..amount.." ]",plrsOnline,0,255,255,true)
		outputChatBox("* The Amount Of Give : [ "..amount_.." ]",plrsOnline,0,255,255,true)
		outputChatBox("* Player Name : [ "..name.." ]",plrsOnline,0,255,255,true)
		outputChatBox("* Player Account : [ "..account.." ]",plrsOnline,0,255,255,true)
		outputChatBox("** Player Use This Money : "..getPlayerName(source).."",plrsOnline,0,255,255,true)
		deletedAmountOfSql = executeSQLQuery("DELETE FROM GroupMoney_x22 WHERE Tick=? AND Account=? AND Amount=? AND NameGroup=? AND Name=?",tonumber(tick),tostring(account),tonumber(amount),tostring(getElementData(source,"NameGroup")),tostring(name))
		if ( deletedAmountOfSql ~= false ) then
			getAllMoneyGroup(plrsOnline,getElementData(source,"NameGroup"))
		else
			outputChatBox("* [ Error ] Fail Deleted Amount Of Sql .",source,255,0,0,true)
		end
	else
		outputChatBox("* [ Error ] Please Select Amount .",source,255,0,0,true)
	end
end)

function takeGroupsName()
	local Row = executeSQLQuery("SELECT * FROM Groups_x22")
	if ( type(Row) == "table" and #Row == 0 or not Row ) then
		return {}
	else
		return Row
	end
end

function getAllGroups(plr)
	if ( plr ) then
		local TableGroups = {}
		for _,v in ipairs (takeGroupsName()) do
			table.insert(TableGroups,{groupName = v.NameGroup,ownerName = v.Owner ,})
		end
		triggerClientEvent(plr,"upGroupsToList",plr,TableGroups)
	end
end

function takeMembers(groupName_)
	if ( groupName_ and type(groupName_) == "string" ) then
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE NameGroup=?",tostring(groupName_))
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			return {}
		else
			return Row
		end
	end
end

function getAllMembers(plr,groupName_)
	if ( plr and groupName_ and type(groupName_) == "string" ) then
		local TableMembers = {}
		for _,v in ipairs (takeMembers(groupName_)) do
			table.insert(TableMembers,{NameMember = v.Name,AccountMember = v.Account ,RankMember = v.RankPlayer ,StateMember = v.State,})
		end
		triggerClientEvent(plr,"upMembersToList",plr,TableMembers)
	end
end

function takeMembersSelect(groupName_Select)
	if ( groupName_Select and type(groupName_Select) == "string" ) then
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE NameGroup=?",tostring(groupName_Select))
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			return {}
		else
			return Row
		end
	end
end

function getAllMembersSelect(plr,groupName_Select)
	if ( plr and groupName_Select and type(groupName_Select) == "string" ) then
		local TableMembersSelect = {}
		for _,v in ipairs (takeMembers(groupName_Select)) do
			table.insert(TableMembersSelect,{NameMembers = v.Name,})
		end
		triggerClientEvent(plr,"upMembersSelectToList",plr,TableMembersSelect)
	end
end

function takeInvites(account)
	if ( account and type(account) == "string" ) then
		local Row = executeSQLQuery("SELECT * FROM GrupsInvite_x22 WHERE Account=?",tostring(account))
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			return {}
		else
			return Row
		end
	end
end

function getAllInvites(plr,account)
	if ( plr and account and type(account) == "string" ) then
		local TableInvites = {}
		for _,v in ipairs (takeInvites(account)) do
			table.insert(TableInvites,{GroupNamePlrSendInvite = v.NameGroup,NamePlrSendInvite = v.Name ,AccountPlrSendInvite = v.Account,})
		end
		triggerClientEvent(plr,"upMyInviteToList",plr,TableInvites)
	end
end

function takeMoneyGroup(nameGroup_)
	if ( nameGroup_ and type(nameGroup_) == "string" ) then
		local Row = executeSQLQuery("SELECT * FROM GroupMoney_x22 WHERE NameGroup=?",tostring(nameGroup_))
		if ( type(Row) == "table" and #Row == 0 or not Row ) then
			return {}
		else
			return Row
		end
	end
end

function getAllMoneyGroup(plr,nameGroup_)
	if ( plr and nameGroup_ and type(nameGroup_) == "string" ) then
		local TableMoney = {}
		for _,v in ipairs (takeMoneyGroup(nameGroup_)) do
			table.insert(TableMoney,{AmountPlayer = v.Amount,NamePlayer = v.Name ,AccountPlayer = v.Account,Rank = v.RankPlayer,Tick = v.Tick,})
		end
		triggerClientEvent(plr,"upMyGroupMoneyToList",plr,TableMoney)
	end
end

function getPlayerFromAccount(account)
	if ( account and type(account) == "string" ) then
		for _,plr in ipairs (getElementsByType("player")) do
			local acc = getPlayerAccount(plr)
			if ( acc ) then
				if ( getAccountName(acc) == tostring(account) ) then
					return plr
				end
			end
		end
	end
	return false
end

function getCountGroups()
	local Count = {}
	local Row = executeSQLQuery("SELECT * FROM Groups_x22")
	for _,check in ipairs(Row) do
		if ( #check.NameGroup == 0 ) then
			return
		end
	end
	for _,groupsName in ipairs (Row) do
		Count[#Count + 1] = groupsName.NameGroup
	end
	return ""..#Count..""
end

function getCountMembers()
	local Count = {}
	local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22")
	for _,check in ipairs(Row) do
		if ( #check.Account == 0 ) then
			return
		end
	end
	for _,members in ipairs (Row) do
		Count[#Count + 1] = members.Account
	end
	return ""..#Count..""
end

function getPlayersOnlineInMyGroup(plr,groupName_)
	if ( plr and groupName_ and type(groupName_) == "string" ) then
		for _,plrs in ipairs(getElementsByType("player")) do
			if ( getElementData(plrs,groupName_) == getElementData(plr,groupName_) ) then
				return plrs
			end
		end
	end
	return false
end

function getPlayersCountOnlineInMyGroup(plr,groupName_)
	if ( plr and groupName_ and type(groupName_) == "string" ) then
		local PlayersOnline = {}
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE NameGroup=?",tostring(groupName_))
		for _,v in ipairs(Row) do
			if ( v.State == tostring("Online") ) then
				PlayersOnline[#PlayersOnline + 1] = v.State
			end
		end
		return PlayersOnline
	end
	return false
end

function getPlayersCountOfflineInMyGroup(plr,groupName_)
	if ( plr and groupName_ and type(groupName_) == "string" ) then
		local PlayersOffline = {}
		local Row = executeSQLQuery("SELECT * FROM GrupsMembers_x22 WHERE NameGroup=?",tostring(groupName_))
		for _,v in ipairs(Row) do
			if ( v.State == tostring("Offline") ) then
				PlayersOffline[#PlayersOffline + 1] = v.State
			end
		end
		return PlayersOffline
	end
	return false
end